/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: test_mutex6.c 1696 2010-01-01 16:01:25Z ertl-hiro $
 */

/* 
 *		~[ebNX̃eXg(6)
 *
 * yeXg̖ړIz
 *
 *  Dx~[ebNXɑ΂āC^XN̏IC^XN̗D揇
 *  ̉]̃~[ebNX֘ȀԗIɃeXgD
 *
 * yeXgځz
 *
 *	(A) ^XN̏Iiext_tskj
 *		(A-1) bNĂ~[ebNXi1jbN邱ƁD
 *		(A-2) bNĂ~[ebNXi1jbNCb
 *			  N҂Ă^XNbNCDxωC
 *			  邱ƁD
 *		(A-3) bNĂ~[ebNXijׂăbN
 *			  邱ƁD
 *		(A-4) bNĂ~[ebNXijbNCb
 *			  N҂Ă^XNijbNCDx
 *			  C҂邱ƁD̎ɁCŃ~[ebNX
 *			  bN^XNiɃbNĂ~[ebNX҂
 *			  Ă^XNj̕CD揇ʂȂ邱ƁD
 *	(B) ^XN̗D揇ʂ̉]irot_rdqj
 *		(B-1) TPRI_SELFw肵ɁC^XÑx[XDx̗D揇ʂ
 *		@@@]邱ƁD
 *		(B-2) TPRI_SELFw肵ɁC^XŇݗDx̗D揇ʂ
 *		@@@]ȂƁD
 *
 * yeXgڂ̎@z
 *
 *	(A-1)
 *		Dx^XNiTASK2jɃ~[ebNXiMTX1jbNC
 *		ext_tskƁCbN邱ƂmFD
 *	(A-2)
 *		Dx^XNiTASK2jɍDx~[ebNXiMTX1jb
 *		NCʂ̒Dx^XNiTASK3jMTX1҂ԂŁC
 *		TASK2 ext_tskƁCTASK3DxɂȂđ҂邱
 *		ƂmFD
 *	(A-3)
 *		Dx^XNiTASK2jɃ~[ebNX2iMTX1CMTX2jb
 *		NCext_tskƁC̃bN邱ƂmFD
 *	(A-4)
 *		Dx^XNiTASK2jɍDx~[ebNX2iMTX1C
 *		MTX2j̏ŃbNCʂ̒Dx^XN2iTASK3C
 *		TASK4jɂꂼ̃bN҂ԂŁCTASK2ext_tskƁC
 *		TASK3TASK4DxɂȂđ҂邱ƂmFD
 *		CɃbNĂ~[ebNXiMTX1j҂Ă^XN
 *		iTASK3jCTASK4D揇ʂȂ邱ƂmFD
 *	(B-1)
 *		Dx^XN3iTASK2CTASK3CTASK4jsłԂ̎
 *		ɁC1̒Dx^XNiTASK2jɍDx~[ebNX
 *		bNCrot_rdq(TPRI_SELF)ƁCc2̒Dx^XN
 *		̗D揇ʂ]邱ƂmFD
 *	(B-2)
 *		Ɠ󋵂ŁCDx^XN̗D揇ʂ]ȂƂmF
 *		D
 *
 * ygp\[Xz
 *
 *	TASK1: Dx^XNCC^XNCŏN
 *	TASK2: Dx^XN
 *	TASK3: Dx^XN
 *	TASK4: Dx^XN
 *	MTX1: ~[ebNXiTA_CEILINGC͍Dxj
 *	MTX2: ~[ebNXiTA_CEILINGC͍Dxj
 *
 * yeXgV[PXz
 *
 *	== TASK1iDxFj==
 *		call(set_bit_func(bit_mutex))
 *	1:	act_tsk(TASK2)
 *	2:	rot_rdq(TPRI_SELF)
 *	//		FTASK2TASK1
 *	== TASK2-1iDxFj1 ==
 *	3:	loc_mtx(MTX1)
 *	//		FTASK2CFTASK1CMTX1FTASK2
 *	4:	ext_tsk() -> noreturn			... (A-1)
 *	//		FTASK1
 *	== TASK1ij==
 *	5:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *
 *	6:	act_tsk(TASK2)
 *		act_tsk(TASK3)
 *	7:	rot_rdq(TPRI_SELF)
 *	//		FTASK2TASK3TASK1
 *	== TASK2-2iDxFj2 ==
 *	8:	loc_mtx(MTX1)
 *	//		FTASK2CFTASK3TASK1CMTX1FTASK2
 *	9:	slp_tsk()
 *	//		FTASK3TASK1CMTX1FTASK2
 *	== TASK3iDxFj==
 *	10:	loc_mtx(MTX1)
 *	//		FTASK1CMTX1FTASK2TASK3
 *	== TASK1ij==
 *	11:	wup_tsk(TASK2)
 *	//		FTASK2CFTASK1CMTX1FTASK2TASK3
 *	== TASK2-2ij==
 *	12:	ext_tsk() -> noreturn			... (A-2)
 *	//		FTASK3CFTASK1CMTX1FTASK3
 *	== TASK3ij==
 *	13:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		get_pri(TPRI_SELF, &tskpri)
 *		assert(tskpri == HIGH_PRIORITY)
 *		unl_mtx(MTX1)
 *		slp_tsk()
 *	//		FTASK1
 *
 *	== TASK1ij==
 *	14:	act_tsk(TASK2)
 *	15:	rot_rdq(TPRI_SELF)
 *	//		FTASK2TASK1
 *	== TASK2-3iDxFj3 ==
 *	16:	loc_mtx(MTX1)
 *		loc_mtx(MTX2)
 *	//		FTASK2CFTASK1CMTX1FTASK2CMTX2FTASK2
 *	17:	ext_tsk() -> noreturn			... (A-3)
 *	//		FTASK1
 *	== TASK1ij==
 *	18:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TSK_NONE)
 *		assert(rmtx.wtskid == TSK_NONE)
 *
 *	19:	act_tsk(TASK2)
 *		wup_tsk(TASK3)
 *		act_tsk(TASK4)
 *	20:	rot_rdq(TPRI_SELF)
 *	//		FTASK2TASK3TASK4TASK1
 *	== TASK2-4iDxFj4 ==
 *	21:	loc_mtx(MTX1)
 *		loc_mtx(MTX2)
 *	//		FTASK2CFTASK3TASK4TASK1CMTX1FTASK2CMTX2FTASK2
 *	22:	chg_pri(TASK1, HIGH_PRIORITY)
 *	//		FTASK2TASK1CFTASK3TASK4CMTX1FTASK2CMTX2FTASK2
 *	23:	rot_rdq(TPRI_SELF)				... (B-1)(B-2)
 *	//		FTASK2TASK1CFTASK4TASK3CMTX1FTASK2CMTX2FTASK2
 *	24:	slp_tsk()
 *	//		FTASK1CFTASK4TASK3CMTX1FTASK2CMTX2FTASK2
 *	== TASK1ij==
 *	25:	chg_pri(TSK_SELF, TPRI_INI)
 *	//		FTASK4TASK3TASK1CMTX1FTASK2CMTX2FTASK2
 *	== TASK4iDxFj==
 *	26:	loc_mtx(MTX2)
 *	//		FTASK3TASK1CMTX1FTASK2CMTX2FTASK2TASK4
 *	== TASK3ij==
 *	27:	loc_mtx(MTX1)
 *	//		FTASK1CMTX1FTASK2TASK3CMTX2FTASK2TASK4
 *	== TASK1ij==
 *	28:	wup_tsk(TASK2)
 *	//		FTASK2CFTASK1CMTX1FTASK2TASK3CMTX2FTASK2TASK4
 *	== TASK2-4ij==
 *	29:	ext_tsk() -> noreturn			... (A-4)
 *	//		FTASK3TASK4CFTASK1CMTX1FTASK3CMTX2FTASK4
 *	== TASK3ij==
 *	30:	ref_mtx(MTX1, &rmtx)
 *		assert(rmtx.htskid == TASK3)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		ref_mtx(MTX2, &rmtx)
 *		assert(rmtx.htskid == TASK4)
 *		assert(rmtx.wtskid == TSK_NONE)
 *		get_pri(TPRI_SELF, &tskpri)
 *		assert(tskpri == HIGH_PRIORITY)
 *		ext_tsk() -> noreturn
 *	//		FTASK4CFTASK1CMTX2FTASK4
 *	== TASK4ij==
 *	31:	get_pri(TPRI_SELF, &tskpri)
 *		assert(tskpri == HIGH_PRIORITY)
 *		ext_tsk() -> noreturn
 *	//		FTASK1
 *	== TASK1ij==
 *	32:	END
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/logtask.h"
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_mutex6.h"

extern ER	bit_mutex(void);

void
task1(intptr_t exinf)
{
	ER		ercd;
	T_RMTX	rmtx;

	set_bit_func(bit_mutex);

	check_point(1);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = rot_rdq(TPRI_SELF);
	check_ercd(ercd, E_OK);

	check_point(5);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	check_point(6);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(7);
	ercd = rot_rdq(TPRI_SELF);
	check_ercd(ercd, E_OK);

	check_point(11);
	ercd = wup_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(14);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(15);
	ercd = rot_rdq(TPRI_SELF);
	check_ercd(ercd, E_OK);

	check_point(18);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_mtx(MTX2, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TSK_NONE);
	check_assert(rmtx.wtskid == TSK_NONE);

	check_point(19);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = wup_tsk(TASK3);
	check_ercd(ercd, E_OK);

	ercd = act_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(20);
	ercd = rot_rdq(TPRI_SELF);
	check_ercd(ercd, E_OK);

	check_point(25);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(28);
	ercd = wup_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_finish(32);

	check_point(0);
}

static uint_t	task2_count = 0;

void
task2(intptr_t exinf)
{
	ER		ercd;

	switch (++task2_count) {
	case 1:
		check_point(3);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(4);
		ercd = ext_tsk();

		check_point(0);

	case 2:
		check_point(8);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		check_point(9);
		ercd = slp_tsk();
		check_ercd(ercd, E_OK);

		check_point(12);
		ercd = ext_tsk();

		check_point(0);

	case 3:
		check_point(16);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(17);
		ercd = ext_tsk();

		check_point(0);

	case 4:
		check_point(21);
		ercd = loc_mtx(MTX1);
		check_ercd(ercd, E_OK);

		ercd = loc_mtx(MTX2);
		check_ercd(ercd, E_OK);

		check_point(22);
		ercd = chg_pri(TASK1, HIGH_PRIORITY);
		check_ercd(ercd, E_OK);

		check_point(23);
		ercd = rot_rdq(TPRI_SELF);
		check_ercd(ercd, E_OK);

		check_point(24);
		ercd = slp_tsk();
		check_ercd(ercd, E_OK);

		check_point(29);
		ercd = ext_tsk();

		check_point(0);
	}
	check_point(0);
}

void
task3(intptr_t exinf)
{
	ER		ercd;
	PRI		tskpri;
	T_RMTX	rmtx;

	check_point(10);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(13);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK3);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = get_pri(TPRI_SELF, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == HIGH_PRIORITY);

	ercd = unl_mtx(MTX1);
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(27);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(30);
	ercd = ref_mtx(MTX1, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK3);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = ref_mtx(MTX2, &rmtx);
	check_ercd(ercd, E_OK);
	check_assert(rmtx.htskid == TASK4);
	check_assert(rmtx.wtskid == TSK_NONE);

	ercd = get_pri(TPRI_SELF, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == HIGH_PRIORITY);

	ercd = ext_tsk();

	check_point(0);
}

void
task4(intptr_t exinf)
{
	ER		ercd;
	PRI		tskpri;

	check_point(26);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(31);
	ercd = get_pri(TPRI_SELF, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == HIGH_PRIORITY);

	ercd = ext_tsk();

	check_point(0);
}
