/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: test_tex1.c 2007 2010-12-31 05:48:15Z ertl-hiro $
 */

/* 
 *		^XNOɊւeXg(1)
 *
 * yeXg̖ړIz
 *
 *  ^XN^XNO[`N鏈ԗIɃeXgD
 *
 * yeXgځz
 *
 *	(A) ras_tex̃G[o
 *		(A-1) Ώۃ^XNx~
 *		(A-2) Ώۃ^XÑ^XNO[``ĂȂ
 *	(B) dis_tex̃G[o
 *		(B-1) ^XÑ^XNO[``ĂȂ
 *	(C) ena_tex̃G[o
 *		(C-1) ^XÑ^XNO[``ĂȂ
 *	(D) ref_tex̃G[o
 *		(D-1) Ώۃ^XNx~
 *		(D-2) Ώۃ^XÑ^XNO[``ĂȂ
 *	(E) ras_tex̐폈
 *		(E-1) Ώۃ^XN^XNC^XNOCݗD
 *			  x}XNSԂŁCɎsJn
 *		(E-2) Ώۃ^XN^XNłȂ
 *		(E-3) Ώۃ^XN^XNC^XNO֎~
 *		(E-4) Ώۃ^XN^XNŃ^XNOCݗD
 *			  x}XNSłȂ
 *	(F) ena_tex̐폈
 *		(F-1) ^XNOvCݗDx}XNS
 *			  ԂŁCɎsJn
 *		(F-2) ^XNOvȂ
 *		(F-3) ^XNOv邪CݗDx}XNS
 *			  Ȃ
 *	(G) chg_ipm̐폈
 *		(G-1) ^XNOvC^XNOŁC
 *			  ɎsJn
 *		(G-2) ^XNOvȂ
 *		(G-3) ^XNOv邪C^XNO֎~
 *	(H) ^XNfBXpb`ɂN
 *		(H-1) fBXpb`̃^XN^XNOŃ^XNOv
 *			  
 *	(I) ^XNO[`̃^[ɂNiANj
 *	(J) ^XNO[`̖߂莞ɂԕA
 *		(J-1) ^XNɖ߂Ă鎞
 *		(J-2) ^XNO[`AN鎞
 *	(K) ^XNO[`̑dN
 *	(L) ^XNO[`̖߂莞̃^XN؊
 *
 * ygp\[Xz
 *
 *	TASK1: C̃^XND^XNɑ΂ă^XNOv
 *	TASK2: ^XNɑ΂ă^XNOvΏۃ^XN
 *	TASK3: ^XNO[``ĂȂ^XN
 *	TASK4: x~Ԃ̃^XN
 *
 * yeXgV[PXz
 *
 *	== TASK1iDxF10j==
 *	1:	Ԃ̃`FbN
 *		ref_tex(TSK_SELF, &rtex)
 *		ras_tex(TASK3, 0x0001) -> E_OBJ		... (A-2)
 *		ras_tex(TASK4, 0x0001) -> E_OBJ		... (A-1)
 *		ref_tex(TASK3, &rtex) -> E_OBJ		... (D-2)
 *		ref_tex(TASK4, &rtex) -> E_OBJ		... (D-1)
 *	2:	ena_tex()							... (F-2)
 *		ref_tex(TSK_SELF, &rtex)
 *	3:	ras_tex(TSK_SELF, 0x0001)			... (E-1)
 *	== TASK1^XNO[`i1ځj==
 *	4:	Ԃ̃`FbN
 *	5:	dis_dsp() ... 4̏Ԃꂼω
 *		chg_ipm(TMAX_INTPRI)
 *		ena_tex()
 *		loc_cpu()
 *		^[
 *	== TASK1ij==
 *	6:	߂ĂԂ̃`FbN			... (J-1)
 *	7:	dis_dsp() ... fBXpb`֎~C^XNO֎~
 *		dis_tex()
 *	8:	ras_tex(TASK1, 0x0002)				... (E-3)
 *		ref_tex(TSK_SELF, &rtex)
 *	9:	ena_tex()							... (F-1)
 *	== TASK1^XNO[`i2ځj==
 *	10:	Ԃ̃`FbN
 *	11:	ras_tex(TASK1, 0x0001)				... (E-3)
 *		ras_tex(TASK1, 0x0002)				... (E-3)
 *	12:	ena_dsp() ... 3̏Ԃꂼω
 *		chg_ipm(TMAX_INTPRI)
 *		loc_cpu()
 *		^[							... (I)
 *	== TASK1^XNO[`i3ځj==
 *	13:	Ԃ̃`FbN
 *	14:	ena_dsp() ... fBXpb`C^XNO
 *		chg_ipm(TMAX_INTPRI)
 *		ena_tex()
 *		chg_ipm(TIPM_ENAALL)				... (G-2)
 *		chg_ipm(TMAX_INTPRI)
 *	15: ras_tex(TSK_SELF, 0x0004)			... (E-4)
 *		dis_tex()
 *		chg_ipm(TIPM_ENAALL)				... (G-3)
 *		chg_ipm(TMAX_INTPRI)
 *		ena_tex()							... (F-3)
 *	16:	chg_ipm(TIPM_ENAALL)				... (G-1)(K)
 *	== TASK1^XNO[`i4ځj==
 *	17:	Ԃ̃`FbN
 *	18:	dis_dsp() ... 3̏Ԃꂼω
 *		chg_ipm(TMAX_INTPRI)
 *		loc_cpu()
 *		^[
 *	== TASK1^XNO[`i3ڑj==
 *	19:	߂ĂԂ̃`FbN			... (J-2)
 *		^[
 *	== TASK1ij==
 *	20:	߂ĂԂ̃`FbN			... (J-1)
 *	21: ena_dsp()
 *		rot_rdq(TPRI_SELF)
 *	== TASK2iDxF10j	==
 *	22:	Ԃ̃`FbN
 *	23:	ena_tex()
 *		rot_rdq(TPRI_SELF)
 *	== TASK3iDxF10j	==
 *	24:	Ԃ̃`FbN
 *	25:	ena_tex() -> E_OBJ					... (C-1)
 *	26:	dis_tex() -> E_OBJ					... (B-1)
 *		ext_tsk()
 *	== TASK1ij==
 *	27: ras_tex(TASK2, 0x0001)				... (E-2)
 *		ref_tex(TASK2, &rtex)
 *	28:	rot_rdq(TPRI_SELF)					... (H-1)
 *	== TASK2^XNO[`i1ځj==
 *	29:	Ԃ̃`FbN
 *		^[
 *	== TASK2ij==
 *	30: ras_tex(TSK_SELF, 0x0002)
 *	== TASK2^XNO[`i2ځj==
 *	31:	Ԃ̃`FbN
 *	32:	dis_dsp()
 *		rot_rdq(TPRI_SELF)
 *	33:	^[							... (L)
 *	== TASK1ij==
 *	34:	^[i^XNIj
 *	== TASK2ij==
 *	35:	eXgI
 */

#include <kernel.h>
#include <test_lib.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "test_tex1.h"

void
tex_task1(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	switch (texptn) {
	case 0x0001:
		check_point(4);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		/*
		 *  fBXpb`֎~CݗDx}XNύXC^XNO
		 */
		check_point(5);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = ena_tex();
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TMAX_INTPRI, true, true, false);
		break;

	case 0x0002:
		check_point(10);
		check_state(false, false, TIPM_ENAALL, true, true, true);

		/*
		 *  ^XNOv
		 */
		check_point(11);
		ercd = ras_tex(TSK_SELF, 0x0001);
		check_ercd(ercd, E_OK);
		ercd = ras_tex(TSK_SELF, 0x0002);
		check_ercd(ercd, E_OK);

		/*
		 *  fBXpb`CݗDx}XNύXCCPUbN
		 */
		check_point(12);
		ercd = ena_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TMAX_INTPRI, false, true, true);
		break;

	case 0x0003:
		check_point(13);
		check_state(false, false, TIPM_ENAALL, true, true, true);

		/*
		 *  fBXpb`CݗDx}XNύXC^XNO
		 */
		check_point(14);
		ercd = ena_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = ena_tex();
		check_ercd(ercd, E_OK);
		check_state(false, false, TMAX_INTPRI, false, true, false);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);

		/*
		 *  ^XNOv
		 */
		check_point(15);
		ercd = ras_tex(TSK_SELF, 0x0004);

		ercd = dis_tex();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		check_point(16);
		ercd = chg_ipm(TIPM_ENAALL);
		/* Ń^XNO[`삷 */
		check_ercd(ercd, E_OK);

		/*
		 *  ^XNÕ^[ɂ茳̏Ԃɖ߂Ă邱
		 *  `FbN
		 */
		check_point(19);
		check_state(false, false, TIPM_ENAALL, false, false, false);
		break;

	case 0x0004:
		check_point(17);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		/*
		 *  fBXpb`֎~CݗDx}XNύXCCPUbN
		 */
		check_point(18);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);
		ercd = loc_cpu();
		check_ercd(ercd, E_OK);
		check_state(false, true, TMAX_INTPRI, true, true, true);
		break;

	default:
		check_point(0);
		break;
	}
}

void
task1(intptr_t exinf)
{
	ER		ercd;
	T_RTEX	rtex;

	/*
	 *  Ԃ̃`FbN
	 */
	check_point(1);
	check_state(false, false, TIPM_ENAALL, false, false, true);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_DIS) != 0);
	check_assert(rtex.pndptn == 0);

	/*
	 *  ras_tex̃G[o
	 */
	ercd = ras_tex(TASK3, 0x0001);
	check_ercd(ercd, E_OBJ);
	ercd = ras_tex(TASK4, 0x0001);
	check_ercd(ercd, E_OBJ);

	/*
	 *  ref_tex̃G[o
	 */
	ercd = ref_tex(TASK3, &rtex);
	check_ercd(ercd, E_OBJ);
	ercd = ref_tex(TASK4, &rtex);
	check_ercd(ercd, E_OBJ);

	/*
	 *  ^XNŐ
	 */
	check_point(2);
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TIPM_ENAALL, false, false, false);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_ENA) != 0);
	check_assert(rtex.pndptn == 0);

	/*
	 *  ^XNOv
	 */
	check_point(3);
	ercd = ras_tex(TSK_SELF, 0x0001);
	/* Ń^XNO[`삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  ^XNÕ^[ɂ茳̏Ԃɖ߂Ă邱Ƃ
	 *  `FbN
	 */
	check_point(6);
	check_state(false, false, TIPM_ENAALL, false, false, false);

	/*
	 *  fBXpb`֎~C^XNO֎~
	 */
	check_point(7);
	ercd = dis_dsp();
	check_ercd(ercd, E_OK);
	ercd = dis_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TIPM_ENAALL, true, true, true);

	/*
	 *  ^XNOv
	 */
	check_point(8);
	ercd = ras_tex(TASK1, 0x0002);
	check_ercd(ercd, E_OK);
	ercd = ref_tex(TSK_SELF, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_DIS) != 0);
	check_assert(rtex.pndptn == 0x0002);

	/*
	 *  ^XNO
	 */
	check_point(9);
	ercd = ena_tex();
	/* Ń^XNO[`삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  ^XNÕ^[ɂ茳̏Ԃɖ߂Ă邱Ƃ
	 *  `FbN
	 */
	check_point(20);
	check_state(false, false, TIPM_ENAALL, true, true, false);

	/*
	 *  ^XN2ɐ؂芷
	 */
	check_point(21);
	ercd = ena_dsp();
	check_ercd(ercd, E_OK);
	ercd = rot_rdq(TPRI_SELF);
	/* ő̃^XN삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  ^XN2ɑ΂ă^XNOv
	 */
	check_point(27);
	ercd = ras_tex(TASK2, 0x0001);
	check_ercd(ercd, E_OK);
	ercd = ref_tex(TASK2, &rtex);
	check_ercd(ercd, E_OK);
	check_assert((rtex.texstat & TTEX_ENA) != 0);
	check_assert(rtex.pndptn == 0x0001);

	/*
	 *  ^XN2ɐ؂芷
	 */
	check_point(28);
	ercd = rot_rdq(TPRI_SELF);
	/* ő̃^XN삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  ^XNI
	 */
	check_point(34);
}

void
tex_task2(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	switch (texptn) {
	case 0x0001:
		check_point(29);
		check_state(false, false, TIPM_ENAALL, false, false, true);
		break;

	case 0x0002:
		check_point(31);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		/*
		 *  fBXpb`֎~āC^XN؊vD
		 */
		check_point(32);
		ercd = dis_dsp();
		check_ercd(ercd, E_OK);
		ercd = rot_rdq(TPRI_SELF);
		check_ercd(ercd, E_OK);

		/*
		 *  ^XNO[`̃^[ŁC^XN؊
		 *  D
		 */
		check_point(33);
		break;

	default:
		check_point(0);
		break;
	}
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	/*
	 *  Ԃ̃`FbN
	 */
	check_point(22);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  ^XNŐ
	 */
	check_point(23);
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
	check_state(false, false, TIPM_ENAALL, false, false, false);

	/*
	 *  ^XN3ɐ؂芷
	 */
	ercd = rot_rdq(TPRI_SELF);
	/* ő̃^XN삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  ^XNOv
	 */
	check_point(30);
	ercd = ras_tex(TSK_SELF, 0x0002);
	/* Ń^XNO[`삷 */
	check_ercd(ercd, E_OK);

	/*
	 *  eXgI
	 */
	check_finish(35);
}

void
task3(intptr_t exinf)
{
	ER		ercd;

	/*
	 *  Ԃ̃`FbN
	 */
	check_point(24);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  ^XNŐ
	 */
	check_point(25);
	ercd = ena_tex();
	check_ercd(ercd, E_OBJ);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  ^XNŐ֎~
	 */
	check_point(26);
	ercd = dis_tex();
	check_ercd(ercd, E_OBJ);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	/*
	 *  ^XNI
	 */
	ercd = ext_tsk();
	check_point(0);
}

void
task4(intptr_t exinf)
{
	check_point(0);
}

void
tex_task4(TEXPTN texptn, intptr_t exinf)
{
	check_point(0);
}
